//注意是async 引用的时候可以await
async function ajax(options) {
    return new Promise((resolve, reject) => {
        const xhr = new XMLHttpRequest();
        const method = options.method.toUpperCase();
        xhr.onreadystatechange = () => {
            // xhr.readyState == 4 请求已完成，且响应已就绪
            if (xhr.readyState !== 4 || xhr.status === 0)
                return;
            const responseData = JSON.parse(xhr.response);
            // 当 readyState 等于 4 且status为 200 时，表示响应已就绪：
            if (xhr.status >= 200 && xhr.status < 300) {
                resolve(responseData);
            }
            else {
                reject(`request failed with status code ${xhr.status}`);
            }
        };
        if (method === 'GET') {
            let str = "?";
            let param = options.data;
            for (let i in param) {
                str += (str == "?") ? `${i}=${param[i]}` : `&${i}=${param[i]}`;
            }
            xhr.open(method, options.url + str, true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.send(options.data);
        }
        if (method === 'POST') {
            xhr.open(method, options.url, true);
            xhr.setRequestHeader('Content-type', 'application/json');
            xhr.send(JSON.stringify(options.data));
        }
    });
}
let option = {
    method: "POST",
    url: "http://192.168.1.123:8088/api/get",
    data: {
        id: "ddddd"
    }
};
ajax(option).then((e) => {
    console.log(e);
});
// export default ajax
// export default {};
